/*
Peter Blockley 5/10/03
Program for converting MP3 to WMA to BASE64 and upload files to phone
*/


#include <stdlib.h>
#include <stdio.h>
#include <process.h> //spawnl
#include <dir.h>     //readdir
#include <dirent.h>  //DIR
#include <errno.h>  //spawnl(error codes)

int get_next(DIR *dir1, char *batch_path, char *file)
{
        /*
        get next file in batch
        takes in directory: dir1
        directory path: batch_path
        returns file with path: file
        */

        struct dirent *ent;
        char ext[_MAX_EXT];
        char temp[100];
        int flag;

        while ((ent = readdir(dir1)) != NULL)
        {
                _splitpath(ent->d_name,NULL,NULL,NULL,ext);
                if (!strcmpi(ext, ".mp3")) break;
        };

        if (ent==NULL) return 1;
        sprintf(file, "%s\\%s", batch_path, ent->d_name);
        return 0;
}

int help()
{
        //returns help
        printf("Peter Blockley - 5 Oct 2003\n");
        printf("MP3 Uploader\n");
        printf("(Converts MP3 files to WMA files and uploads to phone)\n\n");
        printf("Usage: mp3_uploader <file> <bit-rate> <com>\n\n");
        printf("<file>     - mp3 file to upload(eg. song.mp3)\n");
        printf("             if file has spaces, use quotations eg(\"song title.mp3\")\n");
        printf("             for batch mode, specify directory: eg(\".\\music\", \".\", \".\\music\\*.*\")\n\n");
        printf("<bit-rate> - WMA Bit rate(64, 96, 128)\n\n");
        printf("<com>      - COM port number(eg. 4)\n");
        printf("             COM port number available, when phone plugged in, from:\n");
        printf("             control panel->system->hardware->device manager->ports->USB OBEX Port\n");
        return 0;
};

int main(int argc, char* argv[])
{
        //declarations
        DIR *dir1;
        struct dirent *ent;

        char s[_MAX_PATH];
        char drive[_MAX_DRIVE];
        char dir[_MAX_DIR];
        char file[_MAX_FNAME];
        char ext[_MAX_EXT];

        char batch_path[_MAX_PATH];
        char mp3_name[_MAX_PATH];
        char mp3_name1[_MAX_PATH];
        char file_name[_MAX_FNAME];
        char lame_name[_MAX_FNAME];
        char WM8EUTIL_name[_MAX_FNAME];
        char base64_converter[_MAX_FNAME];
        char upload_name[_MAX_FNAME];
        char wav_name[_MAX_PATH];
        char wma_name[_MAX_PATH];
        char base64_name[_MAX_PATH];
        char wav_name1[_MAX_PATH];
        char wma_name1[_MAX_PATH];
        char base64_name1[_MAX_PATH];
        char com_num[6];
        char WMA_profile[6];
        char old_wma_name[_MAX_PATH];

        char *str;
        char ch;
        char byte;

        int child;
        int bit_rate;
        int index;
        int batch_mode=0;
        int status;

        long file_length;

        FILE *in;

        old_wma_name[0]=NULL;

        //check for number of arguments
        if ((argc<4)||(argc>4)) return help();

        //check bit-rate
        bit_rate=atoi(argv[2]);
        if ((bit_rate!=64)&&(bit_rate!=96)&&(bit_rate!=128))
        {
                printf("Invalid Bit-rate\n");
                printf("Please use 64, 96 or 128");
                return 0;
        };
        sprintf(WMA_profile, "a%d", bit_rate);

        //set COM port
        sprintf(com_num, "%d", atoi(argv[3]));

        //get path of file to be uploaded
        _fullpath(s, argv[1], _MAX_PATH);

        //check for file extension
        _splitpath(s,drive,dir,file_name,ext);
        //check file has extension, if not assume batch mode
        if (ext[0]==NULL)
        {
                strcpy(batch_path, s);
                batch_mode=1;
        };
        //check for batch mode
        if (file_name[0]=='*')
        {
                _makepath(batch_path,drive,dir,NULL,NULL);
                batch_path[strlen(batch_path)-1]=NULL;
                batch_mode=1;
        };
        if (batch_mode)
        {
                printf("Batch Mode\n");
                if ((dir1 = opendir(batch_path)) == NULL)
                {
                        perror("Unable to open directory");
                        exit(1);
                };
                //get first file in batch
                if (get_next(dir1, batch_path, s))
                {
                        printf("No files found\n");
                        return 1;
                };

        };

        //process batch of MP3 files
        do
        {
                _splitpath(s,drive,dir,file_name,ext);
                sprintf(mp3_name1, "\"%s\"", s);                //create MP3 file name with full path

                _splitpath(argv[0],drive,dir,file,ext);         //get dir of application files

                _makepath(wav_name,drive,dir,"temp",".wav");    //create file name of tempary wave file
                sprintf(wav_name1, "\"%s\"", wav_name);

                _makepath(wma_name,drive,dir,file_name,".wma"); //create file name of tempary wma file
                sprintf(wma_name1, "\"%s\"", wma_name);

                _makepath(upload_name,drive,dir,"upload",".exe"); //create file name of upload.exe with full path

                _makepath(lame_name,drive,dir,"lame",".exe");     //create file name of lame.exe with full path

                printf("Processing MP3 file");                   //convert mp3 file to wav
                if (spawnl(P_WAIT, lame_name, lame_name, "--silent --decode", mp3_name1, wav_name1, NULL)==-1)
                {
                        printf("\nError accessing lame.exe\n");
                        return 1;
                };

                _makepath(WM8EUTIL_name,drive,dir,"wm8eutil",".exe"); //create file name of wm8eutil.exe with full path
                printf("Processing WMA file:");                       //convert wav file to wma file
                if (spawnl(P_WAIT, WM8EUTIL_name, WM8EUTIL_name, "-input", wav_name1, "-output", wma_name1, "-profile", WMA_profile, "-silent", NULL)==-1)
                {
                        printf("\nError accessing wm8eutil.exe\n");
                        return 1;
                };
                printf("Waiting for previous upload to complete\r");
                child=wait(&status); //wait for previous upload to complete before uploading more

                if ((child==-1)&&(errno!=ECHILD)||(child!=-1)&&(status!=0))
                {
                        printf("An eror has occurred\n");
                        return 1;
                };

                //when previous upload complete, delete previous file.
                DeleteFile(old_wma_name);
                strcpy(old_wma_name,wma_name);

                printf("Uploading: %s.wma                        \n", file_name);
                if (spawnl(P_NOWAIT, upload_name, upload_name, "4", wma_name1, com_num, NULL)==-1)
                {
                        printf("\nError accessing upload.exe\n");
                        return 1;
                };

        } while ((batch_mode)&&!(get_next(dir1, batch_path, s)));

        if (batch_mode&&(closedir(dir1) != 0)) perror("Unable to close directory");

        //delete temp files
        //only one temp.wav file, so only need to delete it once
        DeleteFile(wav_name);

        //wait for uploading to complete
        child=wait(&status);
        if ((child==-1)&&(errno!=ECHILD)||(child!=-1)&&(status!=0))
        {
                printf("An eror has occurred\n");
                return 1;
        };

        //deletes tempary wma file
        DeleteFile(old_wma_name);

        printf("done.                                           \n");

        return 0;
}
