/*
Peter Blockley 2/10/03

Class for uploading data to NEC808 phone

use function VNOTE to uplaod data.
type: 1 - ringtune
      2 - video
      3 - misc
      4 - music
      5 - java (not currently working)


data: pointer to BASE64 data
name: pointer to name of file to send to phone (eg. song1)
file_name: pointer to file name(eg. song1.wma)
file_size: size of file (before BASE64 encoding)

To upload data use the following commands:
SetCommPort() - set com port
OpenCommPort() - open com connection
VNOTE() - send data
CloseCommPort() - close com
*/


#include "phone.h"
#include <stdio.h>
phone_class::phone_class()
{

};

int phone_class::get_bytes(int num)
{
        //gets num bytes from phone
        char temp[20];
        if (ReadBytes(temp, num)==0) return 1;

        return 0;
}

int phone_class::init()
{

        //check phone awake
        PutByte(0x80);
        PutByte(0x00);
        PutByte(0x07);
        PutByte(0x10);
        PutByte(0x00);
        PutByte(0xFF);
        PutByte(0xFF);

        return get_bytes(7);
};

int phone_class::melody()
{
        //output header for melody
        PutByte(0x02);
        PutByte(0x50);
        PutByte(0x00);
        PutByte(0x01);
        PutByte(0x00);
        PutByte(0x21);
        PutByte(0x00);
        PutByte(0x6E);
        PutByte(0x00);
        PutByte(0x65);
        PutByte(0x00);
        PutByte(0x63);
        PutByte(0x00);
        PutByte(0x5F);
        PutByte(0x00);
        PutByte(0x6D);

        PutByte(0x00);
        PutByte(0x65);
        PutByte(0x00);
        PutByte(0x6C);
        PutByte(0x00);
        PutByte(0x6F);
        PutByte(0x00);
        PutByte(0x64);
        PutByte(0x00);
        PutByte(0x79);
        PutByte(0x00);
        PutByte(0x2E);
        PutByte(0x00);
        PutByte(0x76);
        PutByte(0x00);
        PutByte(0x6E);

        PutByte(0x00);
        PutByte(0x74);
        PutByte(0x00);
        PutByte(0x00);
        PutByte(0x48);
        PutByte(0x4F);
        PutByte(0xDC);

        return 224; //224 is the minimum header size when transmitting melody
};

int phone_class::video()
{
        //header for video
        PutByte(0x02);
        PutByte(0x50);
        PutByte(0x00);
        PutByte(0x01);
        PutByte(0x00);
        PutByte(0x1F);
        PutByte(0x00);
        PutByte(0x6E);
        PutByte(0x00);
        PutByte(0x65);
        PutByte(0x00);
        PutByte(0x63);
        PutByte(0x00);
        PutByte(0x5F);
        PutByte(0x00);
        PutByte(0x76);

        PutByte(0x00);
        PutByte(0x69);
        PutByte(0x00);
        PutByte(0x64);
        PutByte(0x00);
        PutByte(0x65);
        PutByte(0x00);
        PutByte(0x6F);
        PutByte(0x00);
        PutByte(0x2E);
        PutByte(0x00);
        PutByte(0x76);
        PutByte(0x00);
        PutByte(0x6E);
        PutByte(0x00);
        PutByte(0x74);

        PutByte(0x00);
        PutByte(0x00);
        PutByte(0x48);
        PutByte(0x4F);
        PutByte(0xDE);

        return 222; //222 minimum header size for video
};

int phone_class::audio()
{
        //header for audio
        PutByte(0x02);
        PutByte(0x50);
        PutByte(0x00);
        PutByte(0x01);
        PutByte(0x00);
        PutByte(0x1F);
        PutByte(0x00);
        PutByte(0x6E);
        PutByte(0x00);
        PutByte(0x65);
        PutByte(0x00);
        PutByte(0x63);
        PutByte(0x00);
        PutByte(0x5F);
        PutByte(0x00);
        PutByte(0x61);

        PutByte(0x00);
        PutByte(0x75);
        PutByte(0x00);
        PutByte(0x64);
        PutByte(0x00);
        PutByte(0x69);
        PutByte(0x00);
        PutByte(0x6F);
        PutByte(0x00);
        PutByte(0x2E);
        PutByte(0x00);
        PutByte(0x76);
        PutByte(0x00);
        PutByte(0x6E);
        PutByte(0x00);
        PutByte(0x74);

        PutByte(0x00);
        PutByte(0x00);
        PutByte(0x48);
        PutByte(0x4F);
        PutByte(0xDE);

        return 222; //222 minimum header size for video
};

int phone_class::misc()
{
        //header for misc
        PutByte(0x02);
        PutByte(0x50);
        PutByte(0x00);
        PutByte(0x01);
        PutByte(0x00);
        PutByte(0x1D);
        PutByte(0x00);
        PutByte(0x6E);
        PutByte(0x00);
        PutByte(0x65);
        PutByte(0x00);
        PutByte(0x63);
        PutByte(0x00);
        PutByte(0x5F);
        PutByte(0x00);
        PutByte(0x6D);

        PutByte(0x00);
        PutByte(0x69);
        PutByte(0x00);
        PutByte(0x73);
        PutByte(0x00);
        PutByte(0x63);
        PutByte(0x00);
        PutByte(0x2E);
        PutByte(0x00);
        PutByte(0x76);
        PutByte(0x00);
        PutByte(0x6E);
        PutByte(0x00);
        PutByte(0x74);
        PutByte(0x00);
        PutByte(0x00);

        PutByte(0x48);
        PutByte(0x4F);
        PutByte(0xE0);
        return 220;  //minimum header size for misc
};

int phone_class::image()
{
        //header for image
        PutByte(0x02);
        PutByte(0x50);
        PutByte(0x00);
        PutByte(0x01);
        PutByte(0x00);
        PutByte(0x1B);
        PutByte(0x00);
        PutByte(0x6E);
        PutByte(0x00);
        PutByte(0x65);
        PutByte(0x00);
        PutByte(0x63);
        PutByte(0x00);
        PutByte(0x5F);
        PutByte(0x00);
        PutByte(0x69);

        PutByte(0x00);
        PutByte(0x6D);
        PutByte(0x00);
        PutByte(0x67);
        PutByte(0x00);
        PutByte(0x2E);
        PutByte(0x00);
        PutByte(0x76);
        PutByte(0x00);
        PutByte(0x6E);
        PutByte(0x00);
        PutByte(0x74);
        PutByte(0x00);
        PutByte(0x00);

        PutByte(0x48);
        PutByte(0x4F);
        PutByte(0xE2);
        return 218;  //minimum header size for misc
};


int phone_class::java()
{
        //test output header for java
        //currently doesn't work
        PutByte(0x02);
        PutByte(0x50);
        PutByte(0x00);
        PutByte(0x01);
        PutByte(0x00);
        PutByte(0x1D);
        PutByte(0x00);
        PutByte(0x6E);
        PutByte(0x00);
        PutByte(0x65);
        PutByte(0x00);
        PutByte(0x63);
        PutByte(0x00);
        PutByte(0x5F);
        PutByte(0x00);
        PutByte(0x6A);

        PutByte(0x00);
        PutByte(0x61);
        PutByte(0x00);
        PutByte(0x76);
        PutByte(0x00);
        PutByte(0x61);
        PutByte(0x00);
        PutByte(0x2E);
        PutByte(0x00);
        PutByte(0x76);
        PutByte(0x00);
        PutByte(0x6E);
        PutByte(0x00);
        PutByte(0x74);
        PutByte(0x00);
        PutByte(0x00);

        PutByte(0x48);
        PutByte(0x4F);
        PutByte(0xE0);
        return 220; //minimum header size for java
};

int phone_class::VNOTE(int type1, char *data, char *name, char *file_name, long file_size)
{
        //type: 1 - ringtune
        //      2 - video
        //      3 - misc
        //      4 - audio
        //      5 - java (not currently working)

        // data - pointer to base64 data
        // name - pointer to name of file with no extention
        // file_name - pointer to file name with extention
        // file_size - original file size before base64 encoding.

        char fs[20];  //string of file size
        int num_bytes;
        int head_count;
        int count;
        int index;
        int remain_bytes;
        int remain_bytes1;
        int remain_bytes2;
        BYTE byte1, byte2;
        int ch;

        sprintf(fs, "%d", file_size);
        num_bytes=strlen(data);

        if (init()) return 1; //initialize connection

        //output header
        switch(type1)
        {
                case 1:
                head_count=melody();
                break;
                case 2:
                head_count=video();
                break;
                case 3:
                head_count=misc();
                break;
                case 4:
                head_count=audio();
                break;
                case 5:
                head_count=java();
                break;
        };

        //Calculate header size
        head_count=head_count+strlen(fs)+strlen(name)+strlen(file_name);

        //output vnote information
        WriteString("BEGIN:VNOTE");
        PutByte(0x0D);
        PutByte(0x0A);
        WriteString("VERSION:1.1");
        PutByte(0x0D);
        PutByte(0x0A);

        WriteString("SUMMARY;CHARSET=UTF-8;ENCODING=QUOTED-PRINTABLE:");
        WriteString(name);
        PutByte(0x0D);
        PutByte(0x0A);

        WriteString("X-NEC-FILENAME;CHARSET=UTF-8;ENCODING=QUOTED-PRINTABLE:");
        WriteString(file_name);
        PutByte(0x0D);
        PutByte(0x0A);
        WriteString("X-NEC-FILESIZE:");
        WriteString(fs);
        PutByte(0x0D);
        PutByte(0x0A);
        WriteString("X-NEC-INDEX:");
        PutByte(0x0D);
        PutByte(0x0A);
        WriteString("BODY;ENCODING=BASE64:");

        WriteBuffer(data, 20480-head_count);    //output data for first packet

        index=20480-head_count;                 //increment index
        if (get_bytes(3)) return 1;             //get 3 bytes from phone(on error quit)

        //output remaining packets of data
        while ((num_bytes-index)>20461)         //check if full packet  (account for end signiture)
        {       //output header
                PutByte(0x02);
                PutByte(0x50);
                PutByte(0x00);
                PutByte(0x48);
                PutByte(0x4F);
                PutByte(0xFD);

                Display(index/20474+1, num_bytes/20474);

                WriteBuffer(&data[index], 20474);       //output data for packet

                index+=20474;                           //output 20474 more bytes

                if (get_bytes(3)) return 1;             //get 3 bytes from phone(on error quit)
        }
        if ((num_bytes-index)>0)
        {
                //very poor implementation of integer to hex conversion
                //calculates number of bytes in packet
                remain_bytes=(num_bytes-index+19);
                remain_bytes1=remain_bytes-(remain_bytes/4096)*4096;
                remain_bytes1=remain_bytes1-(remain_bytes1/256)*256;
                remain_bytes2=(remain_bytes-remain_bytes1)>>8;
                byte1=(unsigned char)remain_bytes1;
                byte2=(unsigned char)remain_bytes2;

                //output number of bytes in packet
                PutByte(0x82);
                PutByte(byte2);
                PutByte(byte1);

                //calculate number of bytes in packet minus 3
                remain_bytes=(num_bytes-index+16);
                remain_bytes1=remain_bytes-(remain_bytes/4096)*4096;
                remain_bytes1=remain_bytes1-(remain_bytes1/256)*256;
                remain_bytes2=(remain_bytes-remain_bytes1)>>8;
                byte1=(unsigned char)remain_bytes1;
                byte2=(unsigned char)remain_bytes2;

                PutByte(0x49);
                PutByte(byte2);
                PutByte(byte1);

                WriteBuffer(&data[index], num_bytes-index); //output remaining data

                //end signiture
                PutByte(0x0D);
                PutByte(0x0A);
                WriteString("END:VNOTE");
                PutByte(0x0D);
                PutByte(0x0A);

                if (get_bytes(3)) return 1; //get 3 bytes from phone(on error quit)
        };

        PutByte(0x81);
        PutByte(0x00);
        PutByte(0x03);
        if (get_bytes(3)) return 1; //get 3 bytes from phone(on error quit)
        return 0;
};

int phone_class::Display(int packet_num, int Total_packets)
{
        //output to user
        printf("Transmitting Packet %d of %d\r", packet_num, Total_packets);
        return 0;
}
